;============================================================================
; DB.INC
;============================================================================




; Public functions.

DB_Init		proto
DB_DeInit	proto
DB_GetNfo	proto	Request:dword,Ndx:dword,pBuf:dword
DB_Search	proto	Flags:dword,pText:dword,nText:dword
DB_GetSearch	proto
DB_SetSearch	proto	Ndx:dword,nItems:dword
DB_GetGrpName	proto	GrpId:dword
DB_GroupMask	proto	Set:dword,GMask:dword
DB_GetThumData	proto	FTHId:dword,Request:dword
DB_SetTypeSpec	proto	DBNdx:dword,GrpListNdx:dword,bText:dword
DB_Export	proto
DB_NDBStop	proto




; DB_GetNfo request codes:

I_GETRECD	equ	0		; Get pointer to record
I_GETNAME	equ	1		; Get File Name
I_GETPATH	equ	2		; Get File Path
I_GETFULL	equ	3		; Get full Path
I_GETGRPI	equ	4		; Get File Group ID
I_GETGRPS	equ	5		; Get File Group ID and Name
I_GETICON	equ	6		; Get Icon Handle
I_GETSRCH	equ	7		; Get Searchable status
I_GETTHUM	equ	8		; Get Thumbnail Handler ID
I_GETFSFX	equ	9		; Get File Suffix
I_GETTMSP	equ	10		; Get TimeStamp




; DB_GetThumData request codes:

T_GETFUNC	equ	0		; Get pointer to handler function
T_GETSFX1	equ	1		; Get first or second file suffix
T_GETSFX2	equ	2		;  it can handle.
T_GETNAME	equ	3		; Get Handler name




; DB_Search flags.
;
; OR mask to set flag and NOT the mask to clear flag.

; The Case flag can be or'd ...

I_SRCHCASE	equ	00010000b	; Case sensitive search

; ... with ONE of these search space specifiers.

I_SRCHNAME	equ	00000001b	; Search in File Name
I_SRCHDATA	equ	00000010b	; Search in File Data
I_SRCHPATH	equ	00000100b	; Search in File Path

; ... and the File Name search can recognise the End flag also.

I_SRCHNEND	equ	00100000b	; End of File Name

; If no flag is set then return all of File array.

I_SRCHRALL	equ	00000000b




; Built-in file Thumbnail Handler IDs.

FTH_Non		equ	0		; no handler
FTH_Txt		equ	1		; Text handler
FTH_Img		equ	2		; GDI+ known read formats




;============================================================================
