;============================================================================
; TUI.ASM
;
; A Time-based User Interface: V1.00 Jan 2006, written by DavK.
;============================================================================




include		tui.inc

.nolist

include		.\comn\comn.inc
include		.\db\db.inc
include		.\sbar\sbar.inc
include		.\time\time.inc

.listall




; Local functions.

GetSysParams	proto
GdipStart	proto
GdipStop	proto
TuiFatalError	proto	pExcept:dword
WriteCpuDump	proto	hFile:dword,pContext:dword
WriteCallStack	proto	hFile:dword,pContext:dword
WriteOSDetails	proto	hFile:dword




.data




; Global.
;
; All global variables reside here.
;
; The 'public' directive is not required as externdef is used (TUI.INC).

G_hTui		dd	0		; handle, Tui
G_ScrnWid	dd	0		; Screen width in pixels
G_ScrnHgt	dd	0		; Screen height in pixels
G_IsNT		dd	0		; flag, WinNT type OS present
G_GdipOk	dd	0		; flag, true if GDI+ loaded ok
G_APIErrCode	dd	0		; API function error code
G_UDBhEvent	dd	0		; handle, UDB Event object
G_UDBhMutex	dd	0		; handle, UDB Mutex
G_UDBStatus	dd	0		; UpdateDB status

; Useful.

G_szNewLine	db	CR,LF,0
		align	dword
G_szTAB		db	TB,0
		align	dword
G_szSpc		db	' ',0
		align	dword


; GDI+ functions.
;
; All the functions we use are declared here, initialised in GdipStart.
;
; Format:
;
; 1. Named location for exported function address
; 2. Asciiz function name for obtaining address in dll

pGdiplusStartup			dd	0
szGdiplusStartup		db	"GdiplusStartup",0
				align	dword
pGdiplusShutdown		dd	0
szGdiplusShutdown		db	"GdiplusShutdown",0
				align	dword
pGdipGetInterpolationMode	dd	0
szGdipGetInterpolationMode	db	"GdipGetInterpolationMode",0
				align	dword
pGdipSetInterpolationMode	dd	0
szGdipSetInterpolationMode	db	"GdipSetInterpolationMode",0
				align	dword
pGdipCreateBitmapFromScan0	dd	0
szGdipCreateBitmapFromScan0	db	"GdipCreateBitmapFromScan0",0
				align	dword
pGdipCreateFromHDC		dd	0
szGdipCreateFromHDC		db	"GdipCreateFromHDC",0
				align	dword
pGdipDeleteGraphics		dd	0
szGdipDeleteGraphics		db	"GdipDeleteGraphics",0
				align	dword
pGdipDisposeImage		dd	0
szGdipDisposeImage		db	"GdipDisposeImage",0
				align	dword
pGdipDrawImageRectI		dd	0
szGdipDrawImageRectI		db	"GdipDrawImageRectI",0
				align	dword
pGdipGetImageGraphicsContext	dd	0
szGdipGetImageGraphicsContext	db	"GdipGetImageGraphicsContext",0
				align	dword
pGdipGraphicsClear		dd	0
szGdipGraphicsClear		db	"GdipGraphicsClear",0
				align	dword
pGdipLoadImageFromFile		dd	0
szGdipLoadImageFromFile		db	"GdipLoadImageFromFile",0
				align	dword
pGdipGetImageWidth		dd	0
szGdipGetImageWidth		db	"GdipGetImageWidth",0
				align	dword
pGdipGetImageHeight		dd	0
szGdipGetImageHeight		db	"GdipGetImageHeight",0
				align	dword




; Private to Tui top level module.


; Tui.

		align	dword
szTuiMutex	db	"TUI",0		; mutex name, single instance test
hTuiMutex	dd	0		; handle, single instance mutex

Msg		MSG	<>
OSData		OSVERSIONINFOA <>
		align	dword




; GDI+.

szGdipDLL	db	"gdiplus.dll",0
		align	dword
hGdip		dd	0		; handle, GDI+ module
tGdip		dd	0		; token, GDI+


; GDI+ message box.

GdipMsgBoxStyle	equ	MB_OK or MB_ICONWARNING or MB_TASKMODAL \
			or MB_TOPMOST or MB_SETFOREGROUND

szGdipCaption	db	"GDI+ initialisation failure",0
		align	dword

szGdipMsg	db	"This is most likely if your are running a "
		db	"Win98/ME system."
		db	CR,LF
		db	"Go to Microsoft and download the GDI Plus runtime "
		db	"update "
		db	CR,LF
		db	"or find GDIPLUS.DLL and copy it to your "
		db	"C:\windows\system "
		db	CR,LF
		db	"directory."
		db	CR,LF,CR,LF
		db	"If this error occurs on an XP system then errr "
		db	".. dunno."
		db	CR,LF,CR,LF
		db	"Either way Tui will still run ok however no image "
		db	"thumbnails "
		db	CR,LF
		db	"will be shown."
		db	CR,LF,CR,LF
		db	"Click OK button to continue.",0
		align	dword




; Tui fatal error messages.

ErrMsgBoxStyle	equ	MB_OK or MB_ICONHAND or MB_TASKMODAL or MB_TOPMOST \
			or MB_SETFOREGROUND

szFatalError	db	"Tui Fatal Error",0
		align	dword

szErrorCrash	db	"CRASHED AND BURNT"
		db	CR,LF,CR,LF
		db	"Error %0.8Xh at %0.8Xh"
		db	CR,LF,0
szAccessViol	db	"Memory Access Violation",0
szFltDivBy0	db	"Float Divide by Zero",0
szIntDivBy0	db	"Integer Divide by Zero",0
szBadInstr	db	"Illegal Intstruction",0
szStackOvf	db	"Stack Overflow",0
		align	dword

szIniError	db	"System Failure"
		db	CR,LF,CR,LF
		db	"Tui code %0.4Xh at %0.8Xh",0
szErrAPIRep	db	CR,LF,CR,LF
		db	"API reports: ",0
		align	dword

szReport	db	CR,LF,CR,LF,
			"When you exit from here this message and ",CR,LF,
			"details will be written to the file TUI.RPT",0
		align	dword

szRegs		db	CR,LF,CR,LF,
			"Registers:",CR,LF,
			"eax = %0.8X",TB,"ebx = %0.8X",TB,"ecx = %0.8X",CR,LF,
			"edx = %0.8X",TB,"esi = %0.8X",TB,"edi = %0.8X",CR,LF,
			"ebp = %0.8X",TB,"esp = %0.8X",TB,"eip = %0.8X",CR,LF,
			"flags = %0.8X",0
		align	dword

szStack		db	CR,LF,CR,LF,
			"Stack:",CR,LF,
			"%0.8X  %0.8X  %0.8X  %0.8X",CR,LF,
			"%0.8X  %0.8X  %0.8X  %0.8X",CR,LF,
			"%0.8X  %0.8X  %0.8X  %0.8X",CR,LF,
			"%0.8X  %0.8X  %0.8X  %0.8X",0
		align	dword

szCallStack	db	CR,LF,CR,LF,
			"Call Stack:",CR,LF,0
		align	dword

szCallStkFmt	db	"ip = %08X",TB,"pFrame = %08X",CR,LF,0
		align	dword

szWindows	db	CR,LF,"Platform: Windows ",0
		align	dword
szWin95		db	"95",0
szWin98		db	"98",0
szWinME		db	"ME",0
szWinNT4	db	"NT4",0
szWin2000	db	"2000",0
szWinXP		db	"XP",0
szWin2003	db	"2003",0
szWinVista	db	"Vista",0
		align	dword

szBuildFmt	db	" Build %4lu ",0

szRptFile	db	"tui.rpt",0
		align	dword




.code




;============================================================================
Tui:
;============================================================================


; Allow only one instance.
;
; Jic user decides to run Tui while within it.


	invoke	CreateMutexA, NULL, TRUE, addr szTuiMutex
	mov	hTuiMutex, eax

	invoke	GetLastError

	.if	(eax == ERROR_ALREADY_EXISTS)
		jmp	@@EndTui
	.endif


; Install Tui final exception handler.


	invoke	SetUnhandledExceptionFilter, addr TuiFatalError


; (Log file)


	if Dbg_Log	;++++++++++++++++++++++++++++++++++++++++++++++++++++
			invoke	Dbg_LogOpen
	endif		;++++++++++++++++++++++++++++++++++++++++++++++++++++


; System parameters.


	invoke	GetSysParams


; GDI+.


	invoke	GdipStart


; Module Initialisation, order is important!.


	invoke	DB_Init			; Set up Database,
	invoke	Time_Init		;  Time window,
	invoke	SBar_Init		;    SideBar window and away we go..


; Message loop.


	.while	TRUE

		invoke	GetMessageA, addr Msg, NULL, 0, 0

		; If a message other than WM_QUIT, returns <>0.
		; If WM_QUIT message the return value is 0.
		; If there is an error, the return value is -1.

		.break	.if (sdword ptr eax < 1)

		invoke	TranslateMessage, addr Msg
		invoke	DispatchMessageA, addr Msg

	.endw


; If aborting from New Database dialog, we come here to shut down nicely.

G_Tui_Exit::


; De-initialise modules.


	invoke	Time_DeInit		; Time window objects
	invoke	SBar_DeInit		; SBar window objects
	invoke	DB_DeInit  		; Database structures etc


; GDI+.


	invoke	GdipStop


; (Log file)


	if Dbg_Log	;++++++++++++++++++++++++++++++++++++++++++++++++++++
			invoke	Dbg_LogClose
	endif		;++++++++++++++++++++++++++++++++++++++++++++++++++++


; Release our Mutex handle.


	invoke	CloseHandle, hTuiMutex


; Exit.


@@EndTui:


	xor	eax, eax
	invoke	ExitProcess, eax


;============================================================================




;----------------------------------------------------------------------------
GetSysParams	proc	uses esi
;-----------
;
; Get base system parameters.
;
;
; Entry		n/a
;
;
; Exit		various
;----------------------------------------------------------------------------


; Basic stuff.


	invoke	GetModuleHandleA, NULL
	mov	G_hTui, eax

	invoke	GetSystemMetrics, SM_CXSCREEN
	mov	G_ScrnWid, eax

	invoke  GetSystemMetrics, SM_CYSCREEN
	mov	G_ScrnHgt, eax

	invoke	InitCommonControls


; Detect 9x/NT Windows version.


	lea	esi, OSData
	mov	[esi + OSVERSIONINFOA.dwOSVersionInfoSize], sizeof OSVERSIONINFOA

	invoke	GetVersionExA, esi

	mov	eax, [esi + OSVERSIONINFOA.dwPlatformId]

	.if	(eax == VER_PLATFORM_WIN32_NT)
		mov	eax, 1
	.else
		xor	eax, eax
	.endif

	mov	G_IsNT, eax


; Setup Tui Initialisation file.


	invoke	File_TuiSetIni


	ret


GetSysParams	endp
;----------------------------------------------------------------------------




;----------------------------------------------------------------------------
GdipStart	proc
;--------
;
; Startup GDI+.
;
; If this fails then the GDI+ functions throughout are disabled.
;
;
; Entry		n/a
;
;
; Exit		External:
;
;		G_GdipOk	true if load ok, else false
;		tGdip		token, GDI+
;		hGdip		handle, gdiplus module
;
;
; Notes
;
; GDI+ is dynamically loaded so we can detect if gdiplus.dll is present as
; may not be the case if we are running under Win98/ME/2000. If statically
; linked then the dll loader will just abort with the file not found error
; message. We could use the linker /DELAYLOAD directive however there are
; complications:
;
; - Need DELAYIMP.LIB from MSVC6 or from MSVC7 if using Link 7.00
; - Would need to add in our own error hook if the load failed.
;
; The following is lengthy but along with the DDPROTO macro works fine.
;----------------------------------------------------------------------------


if GdipOff	;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

		mov	G_GdipOk, FALSE

else		;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


	local	GdipSI		:GdiplusStartupInput


; Preamble, load the dll and function pointers.


	invoke	LoadLibrary, addr szGdipDLL
	.if	(eax == 0)
		jmp	@@LoadFail
	.endif
	mov	hGdip, eax

	invoke	GetProcAddress, hGdip, addr szGdiplusStartup
	.if	(eax == 0)
		jmp	@@LoadFail
	.endif
	mov	pGdiplusStartup, eax

	invoke	GetProcAddress, hGdip, addr szGdiplusShutdown
	.if	(eax == 0)
		jmp	@@LoadFail
	.endif
	mov	pGdiplusShutdown, eax

	invoke	GetProcAddress, hGdip, addr szGdipGetInterpolationMode
	.if	(eax == 0)
		jmp	@@LoadFail
	.endif
	mov	pGdipGetInterpolationMode, eax

	invoke	GetProcAddress, hGdip, addr szGdipSetInterpolationMode
	.if	(eax == 0)
		jmp	@@LoadFail
	.endif
	mov	pGdipSetInterpolationMode, eax

	invoke	GetProcAddress, hGdip, addr szGdipCreateBitmapFromScan0
	.if	(eax == 0)
		jmp	@@LoadFail
	.endif
	mov	pGdipCreateBitmapFromScan0, eax

	invoke	GetProcAddress, hGdip, addr szGdipCreateFromHDC
	.if	(eax == 0)
		jmp	@@LoadFail
	.endif
	mov	pGdipCreateFromHDC, eax

	invoke	GetProcAddress, hGdip, addr szGdipDeleteGraphics
	.if	(eax == 0)
		jmp	@@LoadFail
	.endif
	mov	pGdipDeleteGraphics, eax

	invoke	GetProcAddress, hGdip, addr szGdipDisposeImage
	.if	(eax == 0)
		jmp	@@LoadFail
	.endif
	mov	pGdipDisposeImage, eax

	invoke	GetProcAddress, hGdip, addr szGdipDrawImageRectI
	.if	(eax == 0)
		jmp	@@LoadFail
	.endif
	mov	pGdipDrawImageRectI, eax

	invoke	GetProcAddress, hGdip, addr szGdipGetImageGraphicsContext
	.if	(eax == 0)
		jmp	@@LoadFail
	.endif
	mov	pGdipGetImageGraphicsContext, eax

	invoke	GetProcAddress, hGdip, addr szGdipGraphicsClear
	.if	(eax == 0)
		jmp	@@LoadFail
	.endif
	mov	pGdipGraphicsClear, eax

	invoke	GetProcAddress, hGdip, addr szGdipLoadImageFromFile
	.if	(eax == 0)
		jmp	@@LoadFail
	.endif
	mov	pGdipLoadImageFromFile, eax

	invoke	GetProcAddress, hGdip, addr szGdipGetImageWidth
	.if	(eax == 0)
		jmp	@@LoadFail
	.endif
	mov	pGdipGetImageWidth, eax

	invoke	GetProcAddress, hGdip, addr szGdipGetImageHeight
	.if	(eax == 0)
		jmp	@@LoadFail
	.endif
	mov	pGdipGetImageHeight, eax


; Everything loaded ok, now ask it to start.


	xor	eax, eax
	mov	GdipSI.DebugEventCallback, eax		; NULL
	mov	GdipSI.SuppressBackgroundThread, eax	; FALSE
	mov	GdipSI.SuppressExternalCodecs, eax	; FALSE
	inc	eax
	mov	GdipSI.GdiplusVersion, eax		; Must be version 1

	invoke	GdiplusStartup, addr tGdip, addr GdipSI, NULL

	.if	(eax == 0)

		mov	G_GdipOk, TRUE

	.else

		@@LoadFail:

		mov	G_GdipOk, FALSE

		; Check we loaded the dll ok and if so we must unload it.

		.if	(hGdip)
			invoke	FreeLibrary, hGdip
		.endif

		; Inform user.

		invoke	MessageBoxA, NULL, addr szGdipMsg, addr szGdipCaption,
				GdipMsgBoxStyle

	.endif

endif


	ret


GdipStart	endp
;----------------------------------------------------------------------------




;----------------------------------------------------------------------------
GdipStop	proc
;-------
;
; Shutdown GDI+.
;
;
; Entry		External:
;
;		G_GdipOk	flag
;		tGdip		token, GDI+
;		hGdip		handle, GDI+ module
;
;
; Exit		n/a
;----------------------------------------------------------------------------


	.if	(G_GdipOk)

		invoke	GdiplusShutdown, tGdip
		invoke	FreeLibrary, hGdip

	.endif


	ret


GdipStop	endp
;----------------------------------------------------------------------------




;----------------------------------------------------------------------------
TuiFatalError	proc	uses ebx esi edi, pExcept:dword
;------------
;
;
; Tui top level Exception Filter.
;
; We come here either from a fatal API error or a crash, so report and abort.
;
; It will be entered in the context of either Tui's process or the update
; thread.
;
;
; Entry		pExcept		pointer to EXCEPTION_POINTERS structure
;
;
; Exit		eax		1 (don't show System error message box)
;
; 		We exit to the System exception handler which does a pretty
;		good job of deallocating resources and cleaning up etc so
;		we don't need to explicitly do anything.
;
;
; Notes:
;
; This replaces the UnhandledExceptionFilter that Windows places at the top
; of each thread and process.
;
; EXCEPTION_POINTERS	struct
;   pExceptionRecord	dd	?	; points to this exception's record
;   ContextRecord	dd	?	; points to the CONTEXT structure
; EXCEPTION_POINTERS	ends
;
; EXCEPTION_RECORD	struct
;   ExceptionCode	dd	?	; code creating this exception
;   ExceptionFlags	dd	?	; flags associated with exception
;   pExceptionRecord	dd	?	; associated exception records
;   ExceptionAddress	dd	?	; address the exception occurred
;   NumberParameters	dd	?	; elements in the next field
;   ExceptionInformation dd 15 dup(?)	; Specifies an array of additional
;					; 32 bit arguments that describe the
;					; exception. The maximum is 15
;					; (EXCEPTION_MAXIMUM_PARAMETERS).
; EXCEPTION_RECORD	ends
;
; The RaiseException function raises an exception in the calling thread.
;
; RaiseException,
;	dwExceptionCode,		; exception code
;	dwExceptionFlags,		; continuable exception flag
;	nNumberOfArguments,		; number of arguments in array
;	pArguments			; address of array of arguments
;
; These arguments are forwarded to the Exception Filter handler in the
; EXCEPTION_RECORD structure.
;
; We use the ExceptionCode and the argument array to store our own exception
; report details - see Module error codes etc.
;
;
; Wsprintf uses the C calling convention (caller must cleanup stack). Note
; that INVOKE attaches stack cleanup code to this function invisibly (see a
; listing) so there is no need to do it explicitly.
;----------------------------------------------------------------------------


	local	szErrMsg[512]		:byte
	local	pszAPIMsg		:dword
	local	hFile			:dword		; report file


; Disable reentry here jic we have a crash in a message hander that is within
; the kernel - eg system dialogs such as File or Color choosing. In this case
; the system unhandled exception handler halts and shows the normal errorbox.
;
; Otherwise Tui just appears to exit with no dialog - what has happened is we
; have come here multiple times too quick to see while we were in the
; MessageBox message handler. Finally the MessageBox exits with an error and
; vast amounts of memory appear to have been eaten.
;
; Abandoned as otherwise overcomes our handler unacceptably!.

	;invoke	SetUnhandledExceptionFilter, NULL


; We need to disable any window timers here also or we will get multiple
; reentry if the error has happened inside a timer loop.


	; Disable Time window update on mouse movement.

	invoke	Time_Stop, TRUE

	; Disable New DataBase progress timer.

	invoke	DB_NDBStop


; Deal with fault.


	cld				; prophylactic

	mov	eax, pExcept
	mov	esi, [eax + EXCEPTION_POINTERS.pExceptionRecord]
	mov	edi, [eax + EXCEPTION_POINTERS.ContextRecord]
	mov	ebx, [esi + EXCEPTION_RECORD.ExceptionCode]

	.if	(ebx < TuiErrMin || ebx > TuiErrMax)


		; Not a known error code, probably a crash!.

		invoke	wsprintfA, addr szErrMsg, addr szErrorCrash, ebx,
				[esi + EXCEPTION_RECORD.ExceptionAddress]

		switch	(ebx)

			; Show the more common causes.

			case	EXCEPTION_ACCESS_VIOLATION
				mov	eax, offset szAccessViol
			case	EXCEPTION_FLT_DIVIDE_BY_ZERO
				mov	eax, offset szFltDivBy0
			case	EXCEPTION_INT_DIVIDE_BY_ZERO
				mov	eax, offset szIntDivBy0
			case	EXCEPTION_ILLEGAL_INSTRUCTION
				mov	eax, offset szBadInstr
			case	STATUS_STACK_OVERFLOW
				; (Masm32 includes don't define
				;  EXCEPTION_STACK_OVERFLOW)
				mov	eax, offset szStackOvf
			default
				xor	eax, eax
		endsw

		.if	(eax)
			invoke	szCatStr, addr szErrMsg, eax
		.endif


	.else


		; Tui code, an API error has occurred.
		;
		; The first string is the heading, Module identifier and
		; address. Note the address is the eip following the call
		; to RaiseException.

		invoke	wsprintfA, addr szErrMsg, addr szIniError, ebx,
				[esi + EXCEPTION_RECORD.ExceptionAddress]

		invoke	szCatStr, addr szErrMsg, addr G_szNewLine


		; The next is the Module string plus a substring indexed
		; by the TUI error code. NB ebx, esi are corrupted now.

		mov	eax, [esi + EXCEPTION_RECORD.ExceptionInformation]
		invoke	szCatStr, addr szErrMsg, eax

		and	ebx, 0Fh		; (max of 15 info's)
		shl	ebx, 2
		add	esi, ebx
		mov	eax, [esi + EXCEPTION_RECORD.ExceptionInformation]
		invoke	szCatStr, addr szErrMsg, eax


		; And now the system error string.
		;
		; Ignore if no error indicated (as does happen!).

		.if	(G_APIErrCode)

			xor	edx, edx		; language ID
			mov	dx, SUBLANG_DEFAULT
			shl	edx, 10
			or	dx, LANG_NEUTRAL

			invoke	FormatMessage,
				FORMAT_MESSAGE_ALLOCATE_BUFFER or \
				FORMAT_MESSAGE_FROM_SYSTEM,
				NULL,			; source ignored
				G_APIErrCode,		; API code
				edx,			; language ID
				addr pszAPIMsg,		; buffer
				0,			; min size of buffer
				NULL			; formatting args

			; Errorhandling for the error handler!.

			.if	(eax)

				invoke	szCatStr, addr szErrMsg,
							addr szErrAPIRep
				invoke	szCatStr, addr szErrMsg, pszAPIMsg

				invoke	LocalFree, pszAPIMsg	; free buffer

			.endif

		.endif


	.endif


; Up with message.


	invoke	szCatStr, addr szErrMsg, addr szReport

	invoke	MessageBoxA, NULL, addr szErrMsg, addr szFatalError,
			ErrMsgBoxStyle


; With any luck we can write it and some useful details to the report file.


	invoke	File_Open, addr szRptFile, GENERIC_WRITE, CREATE_ALWAYS,
			FILE_ATTRIBUTE_NORMAL

	.if	(!CARRY?)

		mov	hFile, eax
		invoke	File_WriteStrg, hFile, addr szErrMsg
		invoke	WriteCpuDump, hFile, edi
		invoke	WriteCallStack, hFile, edi
		invoke	WriteOSDetails, hFile
		invoke	File_WriteStrg, hFile, addr G_szNewLine
		invoke	GetModuleFileName, G_hTui, addr szErrMsg, 512
		invoke	File_WriteStrg, hFile, addr szErrMsg
		invoke	File_WriteStrg, hFile, addr G_szNewLine
		invoke	File_Close, hFile

	.endif


; Exit to system exception handler which will clean up and shut down Tui.
;
; eax = 1, don't display system error message box
; eax = 0, show system error message box


	mov	eax, 1


	ret


TuiFatalError	endp
;----------------------------------------------------------------------------




;----------------------------------------------------------------------------
WriteCpuDump	proc	uses ebx esi edi, hFile:dword,pContext:dword
;-----------
;
; Dump Cpu registers and 16 levels of stack to the end of the message string.
;
;
; Entry		hFile		report file handle
;
;		pContext	pointer to the CONTEXT structure
;
;
; Exit		n/a
;----------------------------------------------------------------------------


	local	szMsg[512]		:byte


	mov	ebx, pContext
	lea	edi, szMsg


; Registers.


	invoke	wsprintfA, edi, addr szRegs,
		[ebx+CONTEXT.regEax],[ebx+CONTEXT.regEbx],[ebx+CONTEXT.regEcx],
		[ebx+CONTEXT.regEdx],[ebx+CONTEXT.regEsi],[ebx+CONTEXT.regEdi],
		[ebx+CONTEXT.regEbp],[ebx+CONTEXT.regEsp],[ebx+CONTEXT.regEip],
		[ebx+CONTEXT.regFlag]


; Stack, show 16 levels from the current stack pointer.


	invoke	StrLen, edi
	add	edi, eax

	mov	esi, [ebx + CONTEXT.regEsp]
	mov	ecx, 15

	.repeat

		mov	eax, ecx
		shl	eax, 2			; dwords
		push	[esi + eax]
		dec	ecx

	.until	(SIGN?)

	push	offset szStack
	push	edi
	call	wsprintfA
	add	esp, 16*4 + 8


; Write it out.


	invoke	File_WriteStrg, hFile, addr szMsg


	ret


WriteCpuDump	endp
;----------------------------------------------------------------------------




;----------------------------------------------------------------------------
WriteCallStack	proc	uses ebx esi edi,hFile:dword,pContext:dword
;-------------
;
; Walk the call stack and write the result to the report file.
;
; See Matt Peitrek's MSJExceptionHandler article in MS Systems Journal May
; 1997 "Under the Hood".
;
;
; Entry		hFile		report file handle
;
;		pContext	pointer to the CONTEXT structure
;
;
; Exit		n/a
;
;
; Call Stack
;
; After a call to a function, ebp points to the function's stack frame:
;
;		[ebp+4]		Return address
;	ebp ->	[ebp+0]		Previous ebp value
;		  |		}
;		  |		} saved registers and local vars
;		  |		}
;	esp ->	  -
;
; Thus [ebp+0] is a pointer to the caller's stack frame and so on.
;----------------------------------------------------------------------------


	local	szMsg[64]		:byte


	mov	ebx, pContext

	invoke	File_WriteStrg, hFile, addr szCallStack

	mov	edi, [ebx + CONTEXT.regEip]	; start with entry eip
	mov	esi, [ebx + CONTEXT.regEbp]	; and frame pointer

	.while	TRUE

		invoke	wsprintfA, addr szMsg, addr szCallStkFmt, edi, esi
		invoke	File_WriteStrg, hFile, addr szMsg

		mov	edi, [esi + 4]		; return address
		mov	edx, esi		; now is previous fp

		; Proceed to next higher frame on stack.

		mov	eax, [esi + 0]
		mov	esi, eax		; new frame pointer

		; Frame pointer must be aligned on a DWORD boundary.

		.break	.if (esi & 3)

		; Each frame has to be at a higher address than the
		; preceding frame.

		.break	.if (esi <= edx)

		; Can two DWORDs be read from the supposed frame address?.
		; If not we are in the kernel or somewhere we will get
		; an access violation if we try!.

		invoke IsBadWritePtr, esi, 8
		.break	.if (eax)

	.endw


@@Exit:


	ret


WriteCallStack	endp
;----------------------------------------------------------------------------




;----------------------------------------------------------------------------
WriteOSDetails	proc	uses esi edi, hFile:dword
;-------------
;
; Write the OS details to the report file.
;
;
; Entry		hFile		report file handle
;
;
; Exit		n/a
;
;
; Notes from MS re version numbers and Platform Id:
;
; Version			Major.Minor		PlatformId
; ---------------------------------------------------------------------------
; Windows Server "Longhorn"	6.0		VER_PLATFORM_WIN32_NT
; Windows Vista			6.0			"
; Windows Server 2003 R2	5.2			"
; Windows Server 2003		5.2			"
; Windows XP			5.1			"
; Windows 2000			5.0			"
; Windows Me			4.90		VER_PLATFORM_WIN32_WINDOWS
; Windows 98			4.10			"
; Windows NT 4.0		4.0		VER_PLATFORM_WIN32_NT
; Windows 95			4.0		VER_PLATFORM_WIN32_WINDOWS
;----------------------------------------------------------------------------


	local	szMsg[256]		:byte
	local	szBld[32]		:byte


	invoke	szCopy, addr szWindows, addr szMsg

	mov	esi, offset OSData
	mov	eax, [esi + OSVERSIONINFOA.dwMajorVersion]
	mov	edx, [esi + OSVERSIONINFOA.dwMinorVersion]

	.if	(eax == 4)

		.if	(edx == 0)

			mov	eax, [esi + OSVERSIONINFOA.dwPlatformId]

			.if	(eax == VER_PLATFORM_WIN32_WINDOWS)
				mov	edi, offset szWin95
			.else
				mov	edi, offset szWinNT4
			.endif

		.elseif	(edx == 10)

			mov	edi, offset szWin98

		.elseif	(edx == 90)

			mov	edi, offset szWinME

		.endif

		mov	ecx, [esi + OSVERSIONINFOA.dwBuildNumber]
		and	ecx, 0FFFFh

	.elseif	(eax == 5)

		.if	(edx == 0)
			mov	edi, offset szWin2000
		.elseif	(edx == 1)
			mov	edi, offset szWinXP
		.elseif	(edx == 2)
			mov	edi, offset szWin2003
		.endif

		mov	ecx, [esi + OSVERSIONINFOA.dwBuildNumber]

	.elseif	(eax == 6)

		mov	edi, offset szWinVista
		mov	ecx, [esi + OSVERSIONINFOA.dwBuildNumber]

	.endif

	invoke	wsprintfA, addr szBld, addr szBuildFmt, ecx
	invoke	szCatStr, addr szMsg, edi
	invoke	szCatStr, addr szMsg, addr szBld
	add	esi, OSVERSIONINFOA.szCSDVersion
	invoke	szCatStr, addr szMsg, esi

	invoke	File_WriteStrg, hFile, addr szMsg


	ret


WriteOSDetails	endp
;----------------------------------------------------------------------------




;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Debug stuff.

if Dbg_Log
		include		debug\dbglog.asm
endif

if Dbg_Msgs
		include		debug\dbgmsgs.asm
endif

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++




end	Tui




;============================================================================
